%bcond_with live

%global dasbusver 1.3
%global dnfver 3.6.0
%global dracutver 034-7
%global gettextver 0.19.8
%global gtk3ver 3.22.17
%global isomd5sumver 1.0.10
%global langtablever 0.0.54
%global libarchivever 3.0.4
%global libblockdevver 2.1
%global libtimezonemapver 0.4.1-2
%global libxklavierver 5.4
%global mehver 0.23-1
%global nmver 1.0
%global pykickstartver 3.43-1
%global pypartedver 2.5-2
%global pythonblivetver 3.5.0-1
%global rpmver 4.15.0
%global simplelinever 1.9.0-1
%global utillinuxver 2.15.1

Summary:        Graphical system installer
Name:           anaconda
Version:        38.23.2
Release:        10%{?dist}
License:        GPLv2+ and MIT
URL:            http://fedoraproject.org/wiki/Anaconda
Source0:        https://github.com/rhinstaller/%{name}/releases/download/%{name}-%{version}-1/%{name}-%{version}.tar.bz2
Source1:        opencloudos.conf

Patch0001:      0001-Import-BlockDev-from-blivet-instead-of-gi.patch
Patch5000:      5000-remove-flatpak-support.patch
Patch5001:      5001-remove-gtkdoc-support-for-widgets.patch
Patch5002:      5002-remove-help-button-from-base-window.patch
Patch5004:      5004-Set-gui-default-locale-to-zh_CN.UTF-8.patch
# for f in `grep -nr "America/New_York" | awk -F":" '{print $1}'`;do sed -i 's#America/New_York#Asia/Beijing#g' $f;done
Patch5005:      Set-default-timezone-to-Asia-Beijing.patch
Patch5006:      5006-fixed-some-text-not-being-translated.patch
patch5007:	5007-add-loongarch64-support-for-anaconda-38.23.patch

BuildRequires:	libtool make
BuildRequires:	audit-libs-devel gobject-introspection-devel
BuildRequires:	glade-devel libgnomekbd-devel pango-devel python3-devel
BuildRequires:	systemd gdk-pixbuf2-devel libxml2
BuildRequires:	gettext-devel >= %{gettextver}
BuildRequires:	gtk3-devel >= %{gtk3ver}
BuildRequires:	libxklavier-devel >= %{libxklavierver}
BuildRequires:	rpm-devel >= %{rpmver}
BuildRequires:	libarchive-devel >= %{libarchivever}
BuildRequires:	libtimezonemap-devel >= %{libtimezonemapver}
Requires:		anaconda-gui = %{version}-%{release}
Requires:		anaconda-tui = %{version}-%{release}

%description
This package is a metapackage for the Anaconda installer.

%package core
Summary:		Core of the Anaconda installer
Requires:		python3-libs libselinux-python3 python3-requests python3-requests-file
Requires:		python3-gobject-base python3-dbus python3-pwquality python3-systemd
Requires:		python3-productmd python3-requests-ftp python3-packaging
Requires:		python3-dnf >= %{dnfver}
Requires: 		python3-blivet >= %{pythonblivetver}
Requires: 		python3-blockdev >= %{libblockdevver}
Requires: 		python3-meh >= %{mehver}
Requires: 		python3-rpm >= %{rpmver}
Requires: 		python3-pyparted >= %{pypartedver}
Requires: 		python3-kickstart >= %{pykickstartver}
Requires: 		python3-langtable >= %{langtablever}
Requires: 		python3-dasbus >= %{dasbusver}
Requires: 		util-linux >= %{utillinuxver}
Requires:		NetworkManager >= %{nmver}
Requires:		NetworkManager-libnm >= %{nmver}
Requires:		cracklib-dicts teamd kbd chrony systemd systemd-resolved python3-pid
Requires:		crypto-policies /usr/bin/update-crypto-policies dbus-daemon
Requires: 		anaconda-tui = %{version}-%{release}
Requires: 		(glibc-langpack-en or glibc-all-langpacks)
Provides:		anaconda-images = %{version}-%{release}
Provides:		anaconda-runtime = %{version}-%{release}

%description core
This package provides the program which was used to install your system.

%if %{with live}
%package live
Summary:		Live installation specific files and dependencies
BuildRequires:	desktop-file-utils
Requires:		anaconda-gui = %{version}-%{release}
Requires:		usermode zenity xisxwayland xhost

%description live
This package provides scripts, data and dependencies required for live installations.
%endif

%package install-env-deps
Summary:		Installation environment specific dependencies
Requires:		udisks2-iscsi realmd createrepo_c tmux gdb rsync
Requires:		libblockdev-plugins-all >= %{libblockdevver}
Requires:		isomd5sum >= %{isomd5sumver}
%ifnarch riscv64
Requires:		kexec-tools
%endif

%description install-env-deps
The anaconda-install-env-deps metapackage lists all installation environment dependencies.
This makes it possible for packages (such as Initial Setup) to depend on the main Anaconda 
package without pulling in all the install time dependencies as well.

%package install-img-deps
Summary:		Installation image specific dependencies
Requires:		anaconda-install-env-deps = %{version}-%{release}
Requires:		device-mapper-multipath zram-generator xorg-x11-drivers xorg-x11-server-Xorg
Requires:		dbus-x11 gsettings-desktop-schemas nm-connection-editor librsvg2

%description install-img-deps
The anaconda-install-img-deps metapackage lists all boot.iso installation image dependencies.
Add this package to an image build (eg. with lorax) to ensure all Anaconda capabilities are 
supported in the resulting image.

%package gui
Summary:		Graphical user interface for the Anaconda installer
BuildRequires:	gsettings-desktop-schemas
Requires:		anaconda-core = %{version}-%{release}
Requires:		anaconda-widgets = %{version}-%{release}
Requires:		python3-meh-gui >= %{mehver}
Requires: 		adwaita-icon-theme tigervnc-server-minimal system-logos
Requires: 		libxklavier >= %{libxklavierver}
Requires: 		libtimezonemap >= %{libtimezonemapver}
Requires: 		libgnomekbd nm-connection-editor keybinder3

%description gui
This package provides graphical user interface for the Anaconda installer.

%package tui
Summary:		Textual user interface for the Anaconda installer
Requires:		anaconda-core = %{version}-%{release}
Requires:		python3-simpleline >= %{simplelinever}

%description tui
This package provides textual user interface for the Anaconda installer.

%package widgets
Summary:		A set of custom GTK+ widgets for use with anaconda
Requires:		%{__python3}

%description widgets
This package provides a set of custom GTK+ widgets used by the anaconda installer.

%package widgets-devel
Summary:		Development files for anaconda-widgets
Requires:		glade
Requires:		%{name}-widgets = %{version}-%{release}

%description widgets-devel
This package provides libraries and header files needed for writing the anaconda
installer.  It also provides Python and Glade support files, as well as documentation 
for working with this library.

%package dracut
Summary:		The anaconda dracut module
Requires:		dracut >= %{dracutver}
Requires: 		dracut-network dracut-live xz python3-kickstart

%description dracut
The 'anaconda' dracut module handles installer-specific boot tasks and
options. This includes driver disks, kickstarts, and finding the anaconda
runtime on NFS/HTTP/FTP servers or local disks.

%prep
%autosetup -p1

%build
%configure ANACONDA_RELEASE=%{release}
%make_build

%install
%make_install
find %{buildroot} -type f -name "*.la" -delete

mkdir %{buildroot}%{_datadir}/anaconda/addons
mkdir %{buildroot}%{_datadir}/anaconda/post-scripts

%if %{with live}
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %{buildroot}%{_datadir}/applications/liveinst.desktop
%else
rm -rf \
  %{buildroot}/%{_sysconfdir}/pam.d/liveinst \
  %{buildroot}/%{_sysconfdir}/security/console.apps/liveinst \
  %{buildroot}/%{_sysconfdir}/xdg/autostart/liveinst-setup.desktop \
  %{buildroot}/%{_bindir}/liveinst \
  %{buildroot}/%{_libexecdir}/liveinst-setup.sh \
  %{buildroot}/%{_sbindir}/liveinst \
  %{buildroot}/%{_datadir}/anaconda/gnome \
  %{buildroot}/%{_datadir}/applications/liveinst.desktop
%endif

rm -rf %{buildroot}/%{_datadir}/cockpit/anaconda-webui
rm -f %{buildroot}/%{_datadir}/metainfo/org.cockpit-project.anaconda-webui.metainfo.xml
rm -f %{buildroot}/%{_libexecdir}/webui-desktop

install -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}/profile.d/

%find_lang %{name}

%files

%files core -f %{name}.lang
%license COPYING
%{_unitdir}/*
%{_prefix}/lib/systemd/system-generators/*
%{_prefix}/libexec/anaconda
%exclude %{_prefix}/libexec/anaconda/dd_*
%{_datadir}/anaconda
%dir %{_datadir}/anaconda/post-scripts
%exclude %{_datadir}/anaconda/gnome
%exclude %{_datadir}/anaconda/pixmaps
%exclude %{_datadir}/anaconda/ui
%exclude %{_datadir}/anaconda/window-manager
%exclude %{_datadir}/anaconda/anaconda-gtk.css
%{python3_sitearch}/pyanaconda
%exclude %{python3_sitearch}/pyanaconda/rescue.py*
%exclude %{python3_sitearch}/pyanaconda/__pycache__/rescue.*
%exclude %{python3_sitearch}/pyanaconda/ui/gui/*
%exclude %{python3_sitearch}/pyanaconda/ui/tui/*
%dir %{_sysconfdir}/%{name}
%config %{_sysconfdir}/%{name}/*
%dir %{_sysconfdir}/%{name}/conf.d
%config %{_sysconfdir}/%{name}/conf.d/*
%dir %{_sysconfdir}/%{name}/profile.d
%config %{_sysconfdir}/%{name}/profile.d/*
%{_bindir}/anaconda-cleanup
%{_bindir}/instperf
%{_bindir}/anaconda-disable-nm-ibft-plugin
%{_bindir}/anaconda-nm-disable-autocons
%{_sbindir}/anaconda
%{_sbindir}/handle-sshpw

%files install-env-deps

%files install-img-deps

%if %{with live}
%files live
%config(noreplace) %{_sysconfdir}/pam.d/*
%config(noreplace) %{_sysconfdir}/security/console.apps/*
%{_sysconfdir}/xdg/autostart/*.desktop
%{_libexecdir}/liveinst-setup.sh
%{_datadir}/applications/*.desktop
%{_datadir}/anaconda/gnome
%{_bindir}/liveinst
%{_sbindir}/liveinst
%endif

%files gui
%{_datadir}/anaconda/pixmaps
%{_datadir}/anaconda/ui
%exclude %{_datadir}/anaconda/ui/spokes/blivet_gui.*
%{_datadir}/anaconda/window-manager
%{_datadir}/anaconda/anaconda-gtk.css
%{python3_sitearch}/pyanaconda/ui/gui/*
%exclude %{python3_sitearch}/pyanaconda/ui/gui/spokes/blivet_gui.*

%files tui
%{python3_sitearch}/pyanaconda/rescue.py
%{python3_sitearch}/pyanaconda/__pycache__/rescue.*
%{python3_sitearch}/pyanaconda/ui/tui/*

%files widgets
%{python3_sitearch}/gi/overrides/*
%{_libdir}/libAnacondaWidgets.so.*
%{_libdir}/girepository*/AnacondaWidgets*typelib

%files widgets-devel
%{_includedir}/*
%{_datadir}/glade/catalogs/AnacondaWidgets.xml
%{_libdir}/libAnacondaWidgets.so
%{_libdir}/glade/modules/libAnacondaWidgets.so

%files dracut
%dir %{_prefix}/lib/dracut/modules.d/80%{name}
%{_prefix}/lib/dracut/modules.d/80%{name}/*
%{_prefix}/libexec/anaconda/dd_*

%changelog
* Mon Mar 18 2024 Wenlong Zhang <zhangwenlong@loongson.cn> - 38.23.2-10
- add loongarch64 support for anaconda

* Mon Mar 4 2024 Ze Zhang <bbrucezhang@tencent.com> - 38.23.2-9
- Fixed some text not being translated

* Tue Jan 16 2024 Xiaojie Chen <jackxjchen@tencent.com> - 38.23.2-8
- Change default filesystem type to xfs

* Wed Oct 18 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.23.2-7
- Revert "Solve the problem of unable to find the repo during U-disk boot"

* Mon Oct 09 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.23.2-6
- Solve the problem of unable to find the repo during U-disk boot

* Thu Sep 21 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.23.2-5
- Set gui default locale to zh_CN.UTF-8

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 38.23.2-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 38.23.2-3
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 29 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.23.2-2
- Import BlockDev from blivet instead of gi
- Adjust indentation

* Tue Aug 22 2023 cunshunxia <cunshunxia@tencent.com> - 38.23.2-1
- upgrade to 38.23.2

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 38.4-12
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 38.4-11
- Rebuilt for OpenCloudOS Stream 23

* Wed Feb 22 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-10
- Remove unnecessary code

* Mon Feb 20 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-9
- Revert commit "Change default kernel to 'kernel-stable'" 

* Mon Feb 06 2023 Xin Cheng <denisecheng@tencent.com> - 38.4-8
- Fix spelling error in opencloudos.conf

* Mon Jan 30 2023 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-7
- Set default locale to zh_CN.UTF-8
- Set default timezone to Asia/Beijing

* Tue Dec 20 2022 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-6
- Change default filesystem to ext4
- Change default kernel to 'kernel-stable'

* Thu Dec 15 2022 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-5
- Remove help button from base window

* Thu Dec 15 2022 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-4
- Add stylesheet configuration for OpenCloudOS

* Tue Nov 29 2022 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-3
- Add anaconda configure file for OpenCloudOS

* Thu Nov 17 2022 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-2
- Remove requirements for yelp, NetworkManager-team and libreport-anaconda

* Wed Sep 07 2022 Xiaojie Chen <jackxjchen@tencent.com> - 38.4-1
- Initial build
